package nl.overheid.stelsel.digimelding.actions;

import nl.overheid.stelsel.digimelding.catalogus.CatalogusRequest;
import nl.overheid.stelsel.digimelding.clients.CatalogusClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.net.URISyntaxException;
import java.util.Map;

/**
 * An action performing the 'CatalogusRequest'.
 */
@Component
public class CatalogusAction implements IAction {

    private CatalogusClient catalogusClient;
    private ActionResult actionResult;

    @Autowired
    public CatalogusAction(CatalogusClient catalogusClient) {
        this.catalogusClient = catalogusClient;
    }

    /**
     * Perform a CatalogusRequest. Set the response on the ActionResult.
     *
     * @param args - he arguments of the request (should contains a key for 'oin')
     *
     */
    public void run(Map<String, String> args) throws URISyntaxException {
        CatalogusRequest request = new CatalogusRequest();

        request.setOinBasisregistratie(args.get("oin"));

        this.actionResult = this.catalogusClient.sendRequest(request);
    }

    @Override
    public ActionResult getResult() {
        return this.actionResult;
    }
}

