package nl.overheid.stelsel.digimelding.actions;

import nl.overheid.stelsel.digimelding.catalogus.CatalogusRequest;
import nl.overheid.stelsel.digimelding.clients.CatalogusClient;
import org.junit.Test;
import org.mockito.Mockito;

import java.net.URISyntaxException;
import java.util.HashMap;

import static org.junit.Assert.assertEquals;
import static org.mockito.Matchers.any;
import static org.mockito.Mockito.when;

public class CatalogusActionTest {

    @Test
    public void testRunCatalogusAction() throws URISyntaxException {
        CatalogusClient catalogusClientMock = Mockito.mock(CatalogusClient.class);
        ActionResult resultMock = Mockito.mock(ActionResult.class);

        CatalogusAction catalogusAction = new CatalogusAction(catalogusClientMock);

        when(catalogusClientMock.sendRequest(any(CatalogusRequest.class)))
                .thenReturn(resultMock);

        catalogusAction.run(new HashMap<>());

        assertEquals(catalogusAction.getResult(), resultMock);
    }
}
