package nl.overheid.stelsel.digimelding.actions;

import nl.overheid.stelsel.digimelding.annotatie.EchoRequest;
import nl.overheid.stelsel.digimelding.clients.AnnotatieClient;
import org.junit.Test;
import org.mockito.Mockito;

import java.net.URISyntaxException;
import java.util.HashMap;

import static org.junit.Assert.assertEquals;
import static org.mockito.Matchers.any;
import static org.mockito.Mockito.when;

public class EchoActionTest {

    @Test
    public void testRunEchoAction() throws URISyntaxException {
        AnnotatieClient annotatieClientMock = Mockito.mock(AnnotatieClient.class);
        ActionResult resultMock = Mockito.mock(ActionResult.class);

        EchoAction echoAction = new EchoAction(annotatieClientMock);

        when(annotatieClientMock.sendRequest(any(EchoRequest.class)))
                .thenReturn(resultMock);

        echoAction.run(new HashMap<>());

        assertEquals(echoAction.getResult(), resultMock);
    }
}
