package nl.overheid.stelsel.digimelding.actions;

import nl.overheid.stelsel.digimelding.annotatie.EchoRequest;
import nl.overheid.stelsel.digimelding.clients.AnnotatieClient;
import nl.overheid.stelsel.digimelding.settings.SettingsManager;
import org.junit.Test;
import org.mockito.Mockito;

import java.net.URISyntaxException;
import java.util.HashMap;

import static org.junit.Assert.assertEquals;
import static org.mockito.Matchers.any;
import static org.mockito.Mockito.when;

public class StatusOverzichtActionTest {

    @Test
    public void testRunStatusOverzichtAction() throws URISyntaxException {
        AnnotatieClient annotatieClientMock = Mockito.mock(AnnotatieClient.class);
        SettingsManager settingsManagerMock = Mockito.mock(SettingsManager.class);

        ActionResult resultMock = Mockito.mock(ActionResult.class);

        StatusOverzichtAction statusOverzichtAction =
                new StatusOverzichtAction(annotatieClientMock, settingsManagerMock);

        when(annotatieClientMock.sendRequest(any(EchoRequest.class)))
                .thenReturn(resultMock);

        statusOverzichtAction.run(new HashMap<>());

        assertEquals(statusOverzichtAction.getResult(), resultMock);
    }
}
