package nl.overheid.stelsel.digimelding.clients;

import nl.overheid.stelsel.digimelding.actions.ActionResult;
import org.junit.Test;
import org.mockito.ArgumentCaptor;
import org.mockito.Mockito;
import nl.overheid.stelsel.digimelding.annotatie.EchoRequest;
import org.mockito.invocation.InvocationOnMock;
import org.mockito.stubbing.Answer;
import org.springframework.ws.soap.addressing.client.ActionCallback;
import org.springframework.ws.soap.addressing.core.EndpointReference;
import org.springframework.ws.soap.addressing.messageid.UuidMessageIdStrategy;

import java.net.URI;
import java.net.URISyntaxException;

import static org.junit.Assert.assertEquals;
import static org.mockito.Matchers.any;
import static org.mockito.Mockito.*;

public class AbstractClientTest {

    @Test
    public void testCreateCallback() throws URISyntaxException {
        AbstractClient abstractClient = Mockito.mock(AbstractClient.class);
        when(abstractClient.getBaseUrl()).thenReturn("http://www.digimelding.nl/dmks/cookiebox/");
        EchoRequest request = Mockito.mock(EchoRequest.class);
        Object responseMock = Mockito.mock(Object.class);

        ActionResult actionResultMock = Mockito.mock(ActionResult.class);

        when(abstractClient.sendRequest(any(Object.class), any(ActionCallback.class))).thenReturn(responseMock);
        doCallRealMethod().when(abstractClient).sendRequest(any(Object.class));

        ActionResult actionResult = abstractClient.sendRequest(request);

        verify(abstractClient, times(1)).sendRequest(any(Object.class), any(ActionCallback.class));
        assertEquals(responseMock, actionResult.getResponse());
    }
}
