package nl.overheid.stelsel.digimelding.clients;

import nl.overheid.stelsel.digimelding.interceptors.MessageInterceptor;
import nl.overheid.stelsel.digimelding.interceptors.SecurityRequestInterceptor;
import nl.overheid.stelsel.digimelding.interceptors.SecurityResponseInterceptor;
import nl.overheid.stelsel.digimelding.marshallers.AnnotatieMarshaller;
import nl.overheid.stelsel.digimelding.settings.SettingsManager;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mock;
import org.mockito.Mockito;

import static org.junit.Assert.assertEquals;
import static org.mockito.Mockito.when;

public class AnnotatieClientTest {

    private AnnotatieClient annotatieClient;

    @Mock
    private AnnotatieMarshaller annotatieMarshaller;
    private MessageInterceptor messageInterceptor;
    private SecurityRequestInterceptor securityRequestInterceptor;
    private SecurityResponseInterceptor securityResponseInterceptor;

    private SettingsManager settingsManager;

    @Before
    public void setUp(){
        settingsManager = Mockito.mock(SettingsManager.class);
        when(settingsManager.getAnnotatieEndpoint()).thenReturn("");

        annotatieClient = new AnnotatieClient(settingsManager, annotatieMarshaller,
                messageInterceptor, securityRequestInterceptor, securityResponseInterceptor);
    }
    @Test
    public void testGetBaseUrl(){

        assertEquals(annotatieClient.getBaseUrl(), "http://www.digimelding.nl/dmks/cookiebox/");
    }
}
