package nl.overheid.stelsel.digimelding.clients;

import nl.overheid.stelsel.digimelding.interceptors.MessageInterceptor;
import nl.overheid.stelsel.digimelding.marshallers.CatalogusMarshaller;
import nl.overheid.stelsel.digimelding.settings.SettingsManager;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mock;
import org.mockito.Mockito;

import static org.junit.Assert.assertEquals;
import static org.mockito.Mockito.when;

public class CatalogusClientTest {

    private CatalogusClient catalogusClient;

    @Mock
    private CatalogusMarshaller catalogusMarshaller;
    private MessageInterceptor messageInterceptor;

    private SettingsManager settingsManager;

    @Before
    public void setUp(){
        settingsManager = Mockito.mock(SettingsManager.class);
        when(settingsManager.getAnnotatieEndpoint()).thenReturn("");

        catalogusClient = new CatalogusClient(settingsManager, catalogusMarshaller, messageInterceptor);
    }
    @Test
    public void testGetBaseUrl(){

        assertEquals(catalogusClient.getBaseUrl(), "http://webservices.digimelding.nl/catalogus/");
    }
}
