# Digimelding voorbeeldkoppeling

To run this application, follow the steps below:

## Create a keystore

Create a [keystore](https://docs.oracle.com/cd/E19509-01/820-3503/ggfen/index.html) and add your certificate.

Directly from .p12 file to keystore:

```
keytool -importkeystore -srckeystore P12_FILE_NAME -srcstoretype pkcs12 -srcstorepass P12_PASS -srcalias SOURCE_ALIAS -destkeystore KEYSTORE_FILE -deststoretype jks -deststorepass PASSWORD -destalias ALIAS_NAME
```

With:
P12_FILE_NAME -> The name of your file (with suffix .p12)
P12_PASS -> The password for the .p12 file
SOURCE_ALIAS -> The alias for the certificate in the .p12 file
KEYSTORE_FILE -> The location to where the keystore is created (Suggestion: Add it to resources/keystores)
PASSWORD -> The password for the created .jks keystore
ALIAS_NAME -> The alias for the created certificate in the keystore (should be used in application.properties as well!)

## Update application.properties

Some values have to be set to make sure a (secure) connection to digimelding can be made:

digimelding.ws.endpoint-url -> The URL to which the requests are made

digimelding.ws.key-store -> The location of the .jks file (For example 'keystores/keystore.jks' in case the suggestion at 'Create a keystore' was taken)
digimelding.ws.key-store-password -> The password of the keystore
digimelding.certificate-alias -> The alias of the certificate inside the keystore
digimelding.timestamp-request -> The time a request should remain valid in ms

oin-basisregistratie -> The Oin number provided to you (Should be in the certificate)