package nl.overheid.stelsel.digimelding.configurations;

import nl.overheid.stelsel.digimelding.settings.SettingsManager;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * Configuration which sets up a bean for the SettingsManager from library Core.Digimelding.Koppeling.
 * Default values are set for the bean.
 */
@Configuration
public class ConfigSettings {

    private SettingsManager settingsManager;

    @Bean
    public SettingsManager settingsManager() {
        this.settingsManager = new SettingsManager();
        setSettings();
        return this.settingsManager;
    }

    @Value("${digimelding.ws.endpoint-url-annotatie}")
    private String annotatieUrl;

    @Value("${digimelding.ws.endpoint-url-catalogus}")
    private String catalogusUrl;

    @Value("${digimelding.ws.key-store}")
    private String keyStoreLocation;

    @Value("${digimelding.ws.trust-store}")
    private String trustStoreLocation;

    public void setSettings(){
        if(this.settingsManager != null) {
            this.settingsManager.setCatalogusEndpoint(catalogusUrl);
            this.settingsManager.setAnnotatieEndpoint(annotatieUrl);
        }
    }
}
