package nl.overheid.stelsel.digimelding.controllers;

import de.felixroske.jfxsupport.FXMLController;
import javafx.event.Event;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import org.springframework.beans.factory.annotation.Autowired;
import nl.overheid.stelsel.digimelding.actions.CatalogusAction;
import nl.overheid.stelsel.digimelding.commands.CommandRunner;
import nl.overheid.stelsel.digimelding.commands.ICommand;

@FXMLController
public class CatalogusController extends RequestController {

    @FXML
    private TextArea catalogusRequestResponse;

    @FXML
    private TextArea catalogusRequestRequest;

    @FXML
    private TextField catalogusOinText;

    @FXML
    private Label catalogusRequestStatus;

    @FXML
    private Button sendCatalogusRequestButton;

    @Autowired
    private CatalogusAction action;

    private ICommand command;

    @FXML
    public void initialize() {
        this.request = catalogusRequestRequest;
        this.response = catalogusRequestResponse;
        this.send = sendCatalogusRequestButton;
        this.status = catalogusRequestStatus;

        this.addListener();
    }

    @FXML
    public void executeCatalogusRequest(final Event event) {
        clearRequestAndResponse(catalogusRequestRequest, catalogusRequestResponse);

        String oin = catalogusOinText.getText().trim();

        command = new CommandRunner(action, () -> !oin.equals(""));

        command.addArgument("oin", oin);

        executeRequest(command);
    }

    private void addListener(){
        this.messageInterceptor.setRequestListener(e -> {
            catalogusRequestRequest.setText((String) e.getNewValue());
        });
    }
}