package nl.overheid.stelsel.digimelding.controllers;

import de.felixroske.jfxsupport.FXMLController;
import javafx.event.Event;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import nl.overheid.stelsel.digimelding.actions.EchoAction;
import nl.overheid.stelsel.digimelding.commands.CommandRunner;
import nl.overheid.stelsel.digimelding.commands.ICommand;
import org.springframework.beans.factory.annotation.Autowired;

@FXMLController
public class EchoController extends RequestController {

    @FXML
    private TextArea echoRequestResponse;

    @FXML
    private TextField echoMessageText;

    @FXML
    private TextArea echoRequestRequest;

    @FXML
    private Label echoRequestStatus;

    @FXML
    private TextField echoOinText;

    @FXML
    private Button sendEchoRequestButton;

    @Autowired
    private EchoAction action;
    private ICommand command;

    @FXML
    public void initialize() {
        this.request = echoRequestRequest;
        this.response = echoRequestResponse;
        this.send = sendEchoRequestButton;
        this.status = echoRequestStatus;

        this.addListener();
    }

    @FXML
    public void executeEchoRequest(final Event event) {
        clearRequestAndResponse(echoRequestRequest, echoRequestResponse);

        String message = echoMessageText.getText().trim();
        String oin = echoOinText.getText().trim();

        command = new CommandRunner(action, () -> !message.equals("") && !oin.equals(""));

        command.addArgument("oin", oin);
        command.addArgument("message", message);

        executeRequest(command);
    }

    private void addListener(){
        this.messageInterceptor.setRequestListener(e -> {
            echoRequestRequest.setText((String) e.getNewValue());
        });
    }
}