package nl.overheid.stelsel.digimelding.controllers;

import de.felixroske.jfxsupport.FXMLController;
import javafx.event.Event;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.Menu;
import javafx.scene.layout.Background;
import nl.overheid.stelsel.digimelding.App;
import nl.overheid.stelsel.digimelding.views.CatalogusView;
import nl.overheid.stelsel.digimelding.views.EchoView;
import nl.overheid.stelsel.digimelding.views.SettingsView;
import nl.overheid.stelsel.digimelding.views.StatusOverzichtView;

@FXMLController
public class MenuController {

    @FXML private Menu settingsMenu;

    private SettingsController settingsController;

    @FXML
    public void initialize() {
        addSettingsButton();
    }

    public MenuController(SettingsController settingsController){
        this.settingsController = settingsController;
    }

    @FXML
    private void showEchoView(final Event event) {
        App.showView(EchoView.class);
    }

    @FXML
    private void showStatusOverzichtView(final Event event) {
        App.showView(StatusOverzichtView.class);
    }

    @FXML
    private void showCatalogusView(final Event event) {
        App.showView(CatalogusView.class);
    }

    private void addSettingsButton(){
        Button button = new Button();
        button.setText("Gegevens");
        button.setOnAction((e) -> {
            App.showView(SettingsView.class);
            settingsController.setSettings();
        });
        button.setBackground(Background.EMPTY);

        settingsMenu.setGraphic(button);
    }
}
