package nl.overheid.stelsel.digimelding.controllers;

import de.felixroske.jfxsupport.FXMLController;
import javafx.fxml.FXML;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import nl.overheid.stelsel.digimelding.App;
import nl.overheid.stelsel.digimelding.settings.SettingsManager;
import nl.overheid.stelsel.digimelding.views.LoginView;
import org.springframework.beans.factory.annotation.Autowired;

import java.security.cert.X509Certificate;

@FXMLController
public class SettingsController extends MainController {

    @FXML
    private TextArea serverCertificateSubject;

    @FXML
    private TextArea clientCertificateSubject;

    @FXML
    private Label oin;

    @Autowired
    private SettingsManager settingsManager;

    @FXML
    protected void setSettings() {
        oin.setText(settingsManager.getOin());
        clientCertificateSubject.setText(getCertificateSubject(settingsManager.getClientCertificate()));

        String trustedCertificateSubjects = "";
        for(X509Certificate c: settingsManager.getTrustedCertificates()){
            trustedCertificateSubjects += getCertificateSubject(c);
        }
        serverCertificateSubject.setText(trustedCertificateSubjects);
    }

    private String getCertificateSubject(X509Certificate certificate){
        return certificate.getSubjectDN().toString().replace(",", "\n") + "\n\n";
    }
}