package nl.overheid.stelsel.digimelding.controllers;

import de.felixroske.jfxsupport.FXMLController;
import javafx.event.Event;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import nl.overheid.stelsel.digimelding.actions.StatusOverzichtAction;
import nl.overheid.stelsel.digimelding.commands.CommandRunner;
import nl.overheid.stelsel.digimelding.commands.ICommand;
import org.springframework.beans.factory.annotation.Autowired;

@FXMLController
public class StatusOverzichtController extends RequestController {

    @FXML
    private TextArea statusOverzichtRequestResponse;

    @FXML
    private TextField statusOverzichtOinText;

    @FXML
    private TextArea statusOverzichtRequestRequest;

    @FXML
    private Label statusOverzichtRequestStatus;

    @FXML
    private Button sendStatusOverzichtRequestButton;

    @Autowired
    private StatusOverzichtAction action;

    private ICommand command;

    @FXML
    public void initialize() {
        this.request = statusOverzichtRequestRequest;
        this.response = statusOverzichtRequestResponse;
        this.send = sendStatusOverzichtRequestButton;
        this.status = statusOverzichtRequestStatus;

        this.addListener();
    }

    @FXML
    public void executeStatusOverzichtRequest(final Event event) {
        clearRequestAndResponse(statusOverzichtRequestRequest, statusOverzichtRequestResponse);

        String oin = statusOverzichtOinText.getText().trim();

        command = new CommandRunner(action, () -> !oin.equals(""));

        command.addArgument("oin", oin);

        executeRequest(command);
    }

    private void addListener(){
        this.messageInterceptor.setRequestListener(e -> {
            statusOverzichtRequestRequest.setText((String) e.getNewValue());
        });
    }
}