package nl.overheid.stelsel.digimelding.views;

import de.felixroske.jfxsupport.SplashScreen;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.control.ProgressBar;
import javafx.scene.image.ImageView;
import javafx.scene.layout.VBox;

public class CustomSplashScreen extends SplashScreen {
    private static String DEFAULT_IMAGE;

    public CustomSplashScreen(String image) {
        setImage(image);
    }

    private synchronized void setImage(String image){
        DEFAULT_IMAGE = image;
    }

    public Parent getParent() {
        ImageView imageView = new ImageView(this.getClass().getClassLoader().getResource(this.getImagePath()).toExternalForm());
        ProgressBar splashProgressBar = new ProgressBar();
        splashProgressBar.setPrefWidth(imageView.getImage().getWidth());
        VBox vbox = new VBox();
        vbox.getChildren().addAll(new Node[]{imageView, splashProgressBar});
        return vbox;
    }

    public boolean visible() {
        return true;
    }

    public String getImagePath() {
        return DEFAULT_IMAGE;
    }
}
