﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;

namespace Core.Digimelding.Koppeling.Inspectors
{
    /// <summary>
    /// An inspector which retrieves a raw request and respons.
    /// </summary>
    public class MessageInspector : IMessageInspector, IClientMessageInspector, IEndpointBehavior
    {
        public String sentMessage { get; set; }
        public String receivedMessage { get; set; }

        public event EventHandler RequestSent;

        #region IClientMessageInspector Members
        public void AfterReceiveReply(ref System.ServiceModel.Channels.Message reply, object correlationState)
        {
            this.receivedMessage = reply.ToString();
        }

        public object BeforeSendRequest(ref System.ServiceModel.Channels.Message request, IClientChannel channel)
        {
            this.sentMessage = request.ToString();
            return request;
        }

        #endregion

        #region IEndpointBehavior Members
        public void AddBindingParameters(ServiceEndpoint endpoint, System.ServiceModel.Channels.BindingParameterCollection bindingParameters)
        { }

        public void ApplyClientBehavior(ServiceEndpoint endpoint, ClientRuntime clientRuntime)
        {
            clientRuntime.MessageInspectors.Add(this);
        }

        public void ApplyDispatchBehavior(ServiceEndpoint endpoint, EndpointDispatcher endpointDispatcher)
        { }

        public void Validate(ServiceEndpoint endpoint)
        { }

        public void setRequest(string request)
        {
            this.sentMessage = request;
        }
        #endregion

    }
}
