﻿using System;

namespace Core.Digimelding.Koppeling.Inspectors
{
    /// <summary>
    /// An inspector which offers the option to store and retrieve sent and received messages when performing a request.
    /// </summary>
    public class SoapMessageInspector : IMessageInspector {
        public event EventHandler RequestSent;

        public string sentMessage { get; set; }

        public string receivedMessage { get; set; }

        /// <summary>
        ///     When the request is sent, an event is fired.
        /// </summary>
        /// <param name="request">The request (message) that was sent to the Webservice</param>
        public void setRequest(string request)
        {
            this.sentMessage = request;
            OnRequestSent(new EventArgs());
        }

        protected virtual void OnRequestSent(EventArgs e)
        {
            if (RequestSent != null)
            {
                RequestSent(this, e);
            }
        }

    }
}
