﻿using System.Security.Cryptography.X509Certificates;

namespace Core.Digimelding.Koppeling
{
    public interface ISettingsManager
    {
        string Oin { get; set; }
        string ServerCertificatePath { get; set; }
        string ClientCertificatePath { get; set; }
        string ClientCertificatePassword { get; set; }
        string AnnotatieEndpoint { get; set; }
        string AnnotatieDns { get; set; }
        string CatalogusEndpoint { get; set; }
        string CatalogusDns { get; set; }

        X509Certificate2 getClientCertificate();
        X509Certificate2 getServerCertificate();
        void setClientCertificate(string clientCertificatePath, string clientCertificatePassword);
        void setServerCertificate(string serverCertificatePath);
    }
}
