﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.IO;

namespace Core.Digimelding.Koppeling.Tests.Settings
{
    [TestClass]
    public class SettingsManagerTests
    {
        [TestMethod]
        public void TestSetClientCertificate()
        {
            ISettingsManager settingsManager = new SettingsManager();

            try
            {
                settingsManager.setClientCertificate(getResource("keystore.p12"), "password");
                Assert.Fail();
            } catch(Exception e)
            {
                Assert.IsInstanceOfType(e, typeof(InvalidOperationException));
                Assert.AreEqual("CN=www.test.com", settingsManager.getClientCertificate().Subject);
                Assert.AreEqual("password", settingsManager.ClientCertificatePassword);
                Assert.AreEqual(getResource("keystore.p12"), settingsManager.ClientCertificatePath);
            }
        }

        [TestMethod]
        public void TestSetServerCertificate()
        {
            ISettingsManager settingsManager = new SettingsManager();

            settingsManager.setServerCertificate(getResource("testing.cert"));

            Assert.AreEqual("CN=www.test.com", settingsManager.getServerCertificate().Subject);
            Assert.AreEqual(getResource("testing.cert"), settingsManager.ServerCertificatePath);
        }

        private string getResource(String filename)
        {
            string main = Directory.GetParent(Directory.GetParent(Directory.GetCurrentDirectory()).ToString()).ToString();
            return main + "\\Tests\\Resources\\" + filename;
        }
    }
}
