﻿using Core.Digimelding.Koppeling.Actions;
using Core.Digimelding.Koppeling.Commands;
using System;
using System.Windows;

namespace Voorbeeldkoppeling.Controls
{
    public partial class EchoControl : RequestControl
    {
        private ICommand command;
        private IAction action;

        public EchoControl() {}

        public EchoControl(EchoAction action)
        {
            InitializeComponent();

            this.action = action;
            
            SetControls();
        }

        private void ExecuteRequest(object sender, RoutedEventArgs e)
        {
            command = new CommandRunner(action, this.isValid);

            command.addArgument("message", this.Message.Text);
            command.addArgument("oin", this.Oin.Text);

            executeRequest(command);
        }

        private bool isValid()
        {
            return !string.IsNullOrEmpty(this.Message.Text) && !string.IsNullOrEmpty(this.Oin.Text);
        }

        private void SetControls()
        {
            this.send = this.sendRequestButton;
            this.response = this.echoResponse;
            this.request = this.echoRequest;
            this.status = this.requestStatus;
        }
    }
}
