﻿using Core.Digimelding.Koppeling;
using System.Security.Cryptography.X509Certificates;
using System.Windows;
using System.Windows.Controls;
using Voorbeeldkoppeling.Windows;

namespace Voorbeeldkoppeling.Controls
{
    public partial class SettingsControl : UserControl
    {
        private ISettingsManager settingsManager;
        private LoginWindow window;

        public SettingsControl(ISettingsManager settingsManager)
        {
            InitializeComponent();
            
            this.settingsManager = settingsManager;
            this.Loaded += new RoutedEventHandler(loadSettings);
        }

        public void setSettingsWindow(LoginWindow window)
        {
            this.window = window;
        }
        private void loadSettings(object sender, RoutedEventArgs e)
        {
            this.ClientCertificateSubject.Text = getPrettySubject(settingsManager.getClientCertificate());
            this.ServerCertificateSubject.Text = getPrettySubject(settingsManager.getServerCertificate());

            this.Oin.Content = settingsManager.Oin;
        }

        private void updateSettings(object sender, RoutedEventArgs e)
        {
            Window.GetWindow(this).Visibility = Visibility.Hidden;
            this.window.Show();
        }

        private string getPrettySubject(X509Certificate2 certificate)
        {
            string subject = certificate.Subject.Replace(",", "\n");
           
            return subject;
        }
    }
}
