﻿using Core.Digimelding.Koppeling.Actions;
using Core.Digimelding.Koppeling.Commands;
using System.Windows;

namespace Voorbeeldkoppeling.Controls
{
    public partial class StatusOverzichtControl : RequestControl
    {
        private ICommand command;
        private IAction action;

        public StatusOverzichtControl() {}

        public StatusOverzichtControl(StatusOverzichtAction action)
        {
            InitializeComponent();

            this.action = action;

            SetControls();
        }

        private bool isValid()
        {
            return !string.IsNullOrEmpty(this.Oin.Text);
        }

        private void ExecuteStatusOverzichtRequest(object sender, RoutedEventArgs e)
        {
            command = new CommandRunner(action, this.isValid);
            command.addArgument("oin", this.Oin.Text);

            executeRequest(command);
        }

        private void SetControls()
        {
            this.send = this.sendRequestButton;
            this.response = this.statusOverzichtResponse;
            this.request = this.statusOverzichtRequest;
            this.status = this.requestStatus;
        }
    }
}
