﻿using System.Drawing;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media.Imaging;

namespace Voorbeeldkoppeling.Dialogs
{
    public partial class StacktraceDialog : Window
    {
        private bool isExpanded = false;
        private readonly int expandedSize = 200;
        private readonly int normalSize = 22;

        public StacktraceDialog()
        {
            InitializeComponent();
        }

        public StacktraceDialog(string title, string message, string stackTrace, Icon icon)
        {
            InitializeComponent();
            this.errorMessage.Text = message;
            this.errorStackTrace.Text = stackTrace;
            this.Title = title;

            SetIcon(icon);
            this.Show();
        }

        public void ShowStackTrace(object sender, MouseButtonEventArgs e)
        {
            this.isExpanded = !this.isExpanded;

            if (this.isExpanded) {
                this.stackTraceExpander.Height = this.expandedSize;
            } else {
                this.stackTraceExpander.Height = this.normalSize;
            }
        }

        private void SetIcon(Icon type)
        {
            var image = System.Windows.Interop.Imaging.CreateBitmapSourceFromHIcon(type.Handle,
                Int32Rect.Empty,
                BitmapSizeOptions.FromEmptyOptions());

            this.icon.Source = image;
        }

        private void CloseWindow(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}
