﻿using System.Windows;
using Voorbeeldkoppeling.Controls;

namespace Voorbeeldkoppeling.Windows
{
    public partial class MainWindow : Window
    {
        private EchoControl echoControl;
        private StatusOverzichtControl statusOverzichtControl;
        private CatalogusControl catalogusControl;

        public SettingsControl SettingsControl { get; set; }

        public MainWindow(EchoControl echoControl, StatusOverzichtControl statusOverzichtControl, CatalogusControl catalogusControl,
            SettingsControl settingsControl)
        {
            InitializeComponent();

            this.echoControl = echoControl;
            this.statusOverzichtControl = statusOverzichtControl;
            this.catalogusControl = catalogusControl;
            this.SettingsControl = settingsControl;

            this.contentControl.Content = this.echoControl;
        }

        private void OpenEchoRequest(object sender, RoutedEventArgs e)
        {
            this.contentControl.Content = this.echoControl;
        }

        private void OpenStatusOverzichtRequest(object sender, RoutedEventArgs e)
        {
            this.contentControl.Content = this.statusOverzichtControl;
        }

        private void OpenCatalogusRequest(object sender, RoutedEventArgs e)
        {
            this.contentControl.Content = this.catalogusControl;
        }

        private void OpenSettings(object sender, RoutedEventArgs e)
        {
            this.contentControl.Content = this.SettingsControl;
        }
    }
}
